"{ Package: 'stx:goodies/ston' }"

"{ NameSpace: Smalltalk }"

Object subclass:#STON
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'STON-Core-Facade'
!

!STON class methodsFor:'accessing'!

associationClass
	^ Association
!

classNameKey
	^ #className
!

jsonWriter
	^ STONWriter new
			jsonMode: true;
			referencePolicy: #error;
			yourself
!

listClass
	^ Array
!

mapClass
	^ Dictionary
!

reader
	^ STONReader new
!

writer
	^ STONWriter new
! !

!STON class methodsFor:'convencience'!

fromStream: readStream
	^ (self reader on: readStream) next
!

fromStreamWithComments: readStream
	^ (self reader on: (STONCStyleCommentsSkipStream on: readStream)) next
!

fromString: string
	^ self fromStream: string readStream
!

fromStringWithComments: string
	^ self fromStreamWithComments: string readStream
!

put: object asJsonOnStream: stream
	(self jsonWriter on: stream) nextPut: object
!

put: object asJsonOnStreamPretty: stream
	(self jsonWriter on: stream)
		prettyPrint: true; 
		nextPut: object
!

put: object onStream: stream
	(self writer on: stream) nextPut: object
!

put: object onStreamPretty: stream
	(self writer on: stream)
		prettyPrint: true; 
		nextPut: object
!

toJsonString: object
	^ String streamContents: [ :stream |
		self put: object asJsonOnStream: stream ]
!

toJsonStringPretty: object
	^ String streamContents: [ :stream |
		self put: object asJsonOnStreamPretty: stream ]
!

toString: object
	^ String streamContents: [ :stream |
		self put: object onStream: stream ]
!

toStringPretty: object
	^ String streamContents: [ :stream |
		self put: object onStreamPretty: stream ]
! !

